#region usings
using System;
using System.Net;
using System.ComponentModel.Composition;
using VVVV.PluginInterfaces.V2.Graph;
using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;
using System.Collections;
using System.Collections.Generic;
using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "SendtoPins2", Category = "String", Help = "Basic template with one string in/out", Tags = "")]
	#endregion PluginInfo
	
	public class StringSendtoPins2Node : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultString = "hello c#")]
		public ISpread<string> FInput;

		[Output("Output")]
		public ISpread<string> FOutput;

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins
		
		//called when data for any output pin is requested
		IHDEHost FHDEHost;
		private Dictionary<string, IPin2> FCachedPins = new Dictionary<string, IPin2>();
		private Dictionary<string, IPin2> FExposedPins = new Dictionary<string, IPin2>();
		

		

		
				private string PinNameFromNode(INode2 node)
		{
			string pinName = "";
			if (node.NodeInfo.Systemname == "IOBox (Value Advanced)")
				pinName = "Y Input Value";
			else if (node.NodeInfo.Systemname == "IOBox (String)")
				pinName = "Input String";
			else if (node.NodeInfo.Systemname == "IOBox (Color)")
				pinName = "Color Input";
			else if (node.NodeInfo.Systemname == "IOBox (Enumerations)")
				pinName = "Input Enum";
			else if (node.NodeInfo.Systemname == "IOBox (Node)")
				pinName = "Input Node";
			
			return pinName;
}
		public StringSendtoPins2Node(IHDEHost host)
		{
			FHDEHost = host;
//			FHDEHost.ExposedNodeService.NodeAdded += NodeAddedCB;
//			FHDEHost.ExposedNodeService.NodeRemoved += NodeRemovedCB;
			
			//get initial list of exposed ioboxes
			foreach (var node in FHDEHost.ExposedNodeService.Nodes)
			{
				var pinName = PinNameFromNode(node);
				var pin = node.FindPin(pinName);
			//	pin.Changed += PinChanged;
				FExposedPins.Add(node.GetNodePath(false) + "/" + pinName, pin);
			}
}

		
		public void Evaluate(int SpreadMax)
		{
			
			FOutput.SliceCount = SpreadMax;
IPin2 pin = null;
			for (int i = 0; i < SpreadMax; i++)
			{	
				FOutput[i] = FInput[i].Replace("c#", "vvvv");
				pin = FCachedPins[message.Address];
				
			}
			//FLogger.Log(LogType.Debug, "Logging to Renderer (TTY)");
		}
	}
}
